﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Diagrams.Core;

namespace ShapeFontSIze
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void diagram_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (e.AddedItems.Count != 0)
            {
                // NOTE: e.Addeditems might be Shape, Connection, textShape, containerShape.
                double lastFontSize = (e.AddedItems[0] as RadDiagramShape).FontSize;
                this.CreateCommandAndExecute(lastFontSize);
            }
            
        }

        private void CreateCommandAndExecute(double lastFontSize)
        {
            Action<object> action = new Action<object>((x) => this.SetGlobalFontSize(double.Parse(fontSizeTextBox.Text)));
            Action<object> undoAction = new Action<object>((x) => this.SetGlobalFontSize(lastFontSize));

            UndoableDelegateCommand command = new UndoableDelegateCommand("SetGlobalFontSizeCommand", action, undoAction);
            this.diagram.UndoRedoService.ExecuteCommand(command);
        }

        private void SetGlobalFontSize(double newFont)
        {
            var selectedItems = diagram.SelectedItems;

            foreach (var item in selectedItems)
            {
                (item as RadDiagramShape).FontSize = newFont;
            }
        }
    }
}
